//
//  AppDelegate.m
//  TaskManadgerRss
//
//  Created by Pavel on 6/26/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"




@interface AppDelegate ()
- (NSFetchedResultsController*)fetchedCategories;
- (void)setDefouldCategories;
@end
@implementation AppDelegate

@synthesize window = _window;
@synthesize managedObjectContext = __managedObjectContext;
@synthesize managedObjectModel = __managedObjectModel;
@synthesize persistentStoreCoordinator = __persistentStoreCoordinator;
@synthesize tabBarController;

@synthesize menuController = _menuController;



- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    [self setDefouldCategories];
    
  
    
    TasksViewController *allTsaks = [[TasksViewController alloc] initWithNibName:@"TasksViewController" bundle:nil];
    allTsaks.navigationItem.title = @"All";
    UINavigationController *all = [[UINavigationController alloc] initWithRootViewController:allTsaks];
    all.title = allTsaks.navigationItem.title;
    all.navigationBar.barStyle = UIBarStyleBlackOpaque;
    all.tabBarItem.image = [UIImage imageNamed:@"all.png"];

    TasksViewController *pendingTsaks = [[TasksViewController alloc] initWithNibName:@"TasksViewController" bundle:nil];
    pendingTsaks.navigationItem.title = @"Pending";
    UINavigationController *pending = [[UINavigationController alloc] initWithRootViewController:pendingTsaks];
    pending.title = pendingTsaks.navigationItem.title;
    pending.navigationBar.barStyle = UIBarStyleBlackOpaque;
    pending.tabBarItem.image = [UIImage imageNamed:@"pending.png"];
    
    TasksViewController *completedTsaks = [[TasksViewController alloc] initWithNibName:@"TasksViewController" bundle:nil];
    completedTsaks.navigationItem.title = @"Completed";
    UINavigationController *completed = [[UINavigationController alloc] initWithRootViewController:completedTsaks];
    completed.title = completedTsaks.navigationItem.title;
    completed.navigationBar.barStyle = UIBarStyleBlackOpaque;
    completed.tabBarItem.image = [UIImage imageNamed:@"complete.png"];
    
    NewsViewController *newsController = [[NewsViewController alloc] initWithNibName:@"NewsViewController" bundle:nil];
    newsController.navigationItem.title = @"Category News";
    UINavigationController *news = [[UINavigationController alloc] initWithRootViewController:newsController];
    news.title = newsController.navigationItem.title;
    news.navigationBar.barStyle = UIBarStyleBlackOpaque;
    news.tabBarItem.image = [UIImage imageNamed:@"news.png"];
    
    
    
    DDMenuController *infoRoot = [[DDMenuController alloc] initWithRootViewController:news];
   _menuController = infoRoot;
    
    NSString *nibName = [NSString stringWithFormat:@"InfoViewController%@", prefixDevice];
    InfoViewController *infoR = [[InfoViewController alloc] initWithNibName:nibName bundle:nil];
    infoRoot.rightViewController = infoR;
    
   // MapNewscontroller *mapHalf = [[MapNewscontroller alloc] init];
   // infoRoot.leftViewController = mapHalf;
    
    
    
    newsController.navigationItem.title = @"Category News";

    infoRoot.title = newsController.navigationItem.title;
    infoRoot.tabBarItem.image = [UIImage imageNamed:@"news.png"];

    
    self.tabBarController = [[UITabBarController alloc] init];
    self.tabBarController.viewControllers = [NSArray arrayWithObjects: infoRoot, all, pending, completed,nil];
    
    
    
    self.window.rootViewController = self.tabBarController;
    self.window.backgroundColor = [UIColor whiteColor];
    [self.window makeKeyAndVisible];
    
    return YES;
}

- (NSFetchedResultsController*)fetchedCategories {
    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
    fetchRequest.entity = [NSEntityDescription entityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
    [fetchRequest setFetchBatchSize:20];
    
    NSSortDescriptor *sortDescriptor = [[NSSortDescriptor alloc] initWithKey:@"name" ascending:YES];
    fetchRequest.sortDescriptors = [NSArray arrayWithObjects:sortDescriptor, nil];
    
    NSFetchedResultsController *fetchedResults = [[NSFetchedResultsController alloc] initWithFetchRequest:fetchRequest managedObjectContext:self.managedObjectContext sectionNameKeyPath:nil cacheName:@"Master"];                       
    NSError *error = nil;
	if (![fetchedResults performFetch:&error]) {
	    NSLog(@"Unresolved 0error %@, %@", error, [error userInfo]);
	    abort();
	}
    
    
    return fetchedResults;
}

- (void)setDefouldCategories {
    NSFetchedResultsController *fetchedCategories = self.fetchedCategories;
    if (!fetchedCategories.fetchedObjects.count) {
        NSArray *categoryNames = [NSArray arrayWithObjects:@"Personal", @"Business", @"Family", @"Travel", @"Other", nil];
        
        for (NSString *name in categoryNames) {
            NSEntityDescription *entity = [[fetchedCategories fetchRequest] entity];
            NSManagedObject *category = [NSEntityDescription insertNewObjectForEntityForName:[entity name] inManagedObjectContext:self.managedObjectContext];                                                               
            [category setValue:name forKey:@"name"];
        }
    }
}

- (NSArray*)categories {
    return self.fetchedCategories.fetchedObjects;
}

- (void)applicationWillResignActive:(UIApplication *)application
{

}

- (void)applicationDidEnterBackground:(UIApplication *)application
{

}

- (void)applicationWillEnterForeground:(UIApplication *)application
{

}

- (void)applicationDidBecomeActive:(UIApplication *)application
{

}

- (void)applicationWillTerminate:(UIApplication *)application
{
    [self saveContext];
}

- (void)saveContext
{
    NSError *error = nil;
    NSManagedObjectContext *managedObjectContext = self.managedObjectContext;
    if (managedObjectContext != nil)
    {
        if ([managedObjectContext hasChanges] && ![managedObjectContext save:&error])
        {
            NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
            abort();
        } 
    }
}

#pragma mark - Core Data stack

- (NSManagedObjectContext *)managedObjectContext
{
    if (__managedObjectContext != nil)
    {
        return __managedObjectContext;
    }
    
    NSPersistentStoreCoordinator *coordinator = [self persistentStoreCoordinator];
    if (coordinator != nil)
    {
        __managedObjectContext = [[NSManagedObjectContext alloc] init];
        [__managedObjectContext setPersistentStoreCoordinator:coordinator];
    }
    return __managedObjectContext;
}


- (NSManagedObjectModel *)managedObjectModel
{
    if (__managedObjectModel != nil)
    {
        return __managedObjectModel;
    }
    NSURL *modelURL = [[NSBundle mainBundle] URLForResource:@"TaskManadgerRss" withExtension:@"momd"];
    __managedObjectModel = [[NSManagedObjectModel alloc] initWithContentsOfURL:modelURL];
    return __managedObjectModel;
}


- (NSPersistentStoreCoordinator *)persistentStoreCoordinator
{
    if (__persistentStoreCoordinator != nil)
    {
        return __persistentStoreCoordinator;
    }
    
    NSURL *storeURL = [[self applicationDocumentsDirectory] URLByAppendingPathComponent:@"TaskManadgerRss.sqlite"];
    
    NSError *error = nil;
    __persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel:[self managedObjectModel]];
    if (![__persistentStoreCoordinator addPersistentStoreWithType:NSSQLiteStoreType configuration:nil URL:storeURL options:nil error:&error])
    {
        NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
        abort();
    }    
    
    return __persistentStoreCoordinator;
}

#pragma mark - Application's Documents directory

- (NSURL *)applicationDocumentsDirectory
{
    return [[[NSFileManager defaultManager] URLsForDirectory:NSDocumentDirectory inDomains:NSUserDomainMask] lastObject];
}

@end
