//
//  MapNewscontroller.m
//  TaskManadgerRss
//
//  Created by Pavel on 7/2/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MapNewscontroller.h"


@interface MapNewscontroller ()
- (void)didWillShowAnnotationOnMap;
@end

@implementation MapNewscontroller

@synthesize map;
@synthesize geoDataToParse;
@synthesize fullData;
@synthesize currentTitle;
@synthesize fullDescription;
@synthesize geoLat;
@synthesize geoLon;
@synthesize currentElement;



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
      
    
    UIBarButtonItem *backBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Back" style:UIBarButtonItemStylePlain target:self action:@selector(back)];
    self.navigationItem.leftBarButtonItem = backBarButtonItem;
    
    UIBarButtonItem *curLoc = [[UIBarButtonItem alloc] initWithTitle:@"Currentloc" style:UIBarButtonItemStyleBordered target:self action:@selector(curLoc)];
    self.navigationItem.rightBarButtonItem = curLoc;
    
   
    
    
    UISegmentedControl *segmentedControl = [[UISegmentedControl alloc] initWithItems:
                                            [NSArray arrayWithObjects:
                                             @"Карта",
                                             @"Спутник",
                                             @"Гибрид",
                                             nil]];
    [segmentedControl addTarget:self action:@selector(changeMapType:) forControlEvents:UIControlEventValueChanged];
    segmentedControl.frame = CGRectMake(0.0f, 0.0f, 200.0f, 30.0f);
    segmentedControl.selectedSegmentIndex = 0;
    segmentedControl.segmentedControlStyle = UISegmentedControlStyleBar;
    
   
  
    [self.view addSubview:segmentedControl];

    NSString *url = @"http://www.earthpublisher.com/georss.php";
    
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
    NSURL *urlPath = [NSURL URLWithString:url];
    NSURLRequest *theRequest=[NSURLRequest requestWithURL:urlPath
                                              cachePolicy:NSURLRequestUseProtocolCachePolicy
                                          timeoutInterval:10.0];
    
    NSURLConnection *theConnection=[[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
    if (theConnection) {
        self.geoDataToParse = [NSMutableData data];
    } else {
        NSLog(@"Connection failed");
    }
    
  
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    
    [geoDataToParse appendData:data];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
    //NSString *result = [[NSString alloc] initWithData:geoDataToParse encoding:NSUTF8StringEncoding];
    //NSLog(@"%@",result);
    
    
    self.fullData = [NSMutableArray array];
    NSXMLParser *rssParser = [[NSXMLParser alloc] initWithData:geoDataToParse];
    
    rssParser.delegate = self;
    [rssParser parse];
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict  {
    
    self.currentElement = elementName;
    if ([elementName isEqualToString:@"item"]) {
        self.currentTitle = [NSMutableString string];
        self.geoLon = [NSMutableString string];
        self.geoLat = [NSMutableString string];
        self.fullDescription = [NSMutableString string];
    }
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
    if ([currentElement isEqualToString:@"title"]) 
    {
		[currentTitle appendString:string];
	} 
    else if ([currentElement isEqualToString:@"geo:lat"]) 
    {
		[geoLat appendString:string];
    }
    else if ([currentElement isEqualToString:@"geo:long"]) 
    {
		[geoLon appendString:string];
    }
    else if([currentElement isEqualToString:@"description"])
    {
        [fullDescription appendString:string];
    }
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
    if ([elementName isEqualToString:@"item"]) {
        NSDictionary *newsItem = [NSDictionary dictionaryWithObjectsAndKeys:currentTitle, @"title", geoLat, @"lat", geoLon,@"long", fullDescription, @"fullDescription", nil];
        [fullData addObject:newsItem];
        self.currentTitle = nil;
        self.geoLat = nil;
        self.geoLon = nil;
        self.fullDescription = nil;
        self.currentElement = nil;
    }
}

- (void)parserDidEndDocument:(NSXMLParser *)parser {
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
    [self didWillShowAnnotationOnMap];
    
    //[viewtable reloadData];
}

- (void)didWillShowAnnotationOnMap{
   
   
    
   
    for (int i=0; i < fullData.count; i++) {
        
        NSDictionary *item = [fullData objectAtIndex:i];
        NSString *title = [item objectForKey:@"title"];
        NSString *subTitle = [item objectForKey:@"fullDescription"];
        NSString *longCoord = [item objectForKey:@"long"];
        NSString *latCoord = [item objectForKey:@"lat"];

        Annotation *annotation = [Annotation new];
        annotation.title = title;
        annotation.subtitle = subTitle;
        
        
        annotation.coordinate = CLLocationCoordinate2DMake([longCoord doubleValue], [latCoord doubleValue]);
        [map addAnnotation:annotation];
        
        
    }

}


- (void)back{
    
    CATransition* transition = [CATransition animation];
    transition.duration = 0.5;
    transition.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
    transition.type = kCATransitionPush;
    transition.subtype = kCATransitionFromRight;
    
    [self.navigationController.view.layer addAnimation:transition forKey:nil];
    [[self navigationController] popViewControllerAnimated:NO];
}

- (void)curLoc {
    
   map.showsUserLocation = YES;
   [map setUserTrackingMode:MKUserTrackingModeFollow animated:YES];
    
}

- (void)changeMapType:(UISegmentedControl*)sender {
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
    [UIView setAnimationTransition:UIViewAnimationTransitionFlipFromRight 
                           forView:self.view 
                             cache:NO];
    [UIView commitAnimations];
    if (sender.selectedSegmentIndex == 0) {
        map.mapType = MKMapTypeStandard;
    } else if (sender.selectedSegmentIndex == 1) {
        map.mapType = MKMapTypeSatellite;
    } else if (sender.selectedSegmentIndex == 2) {
        map.mapType = MKMapTypeHybrid;
    }
}


- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation 
{   
    MKPinAnnotationView *annotationView = nil;
 
    return annotationView;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
