//
//  NewsCategorySelectedController.m
//  TaskManadgerRss
//
//  Created by Pavel on 6/26/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "NewsCategorySelectedController.h"


@implementation NewsCategorySelectedController

@synthesize rssData;
@synthesize news;
@synthesize currentElement;
@synthesize currentTitle;
@synthesize pubDate;
@synthesize link;
@synthesize viewtable;
@synthesize selectedItem;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    
    
    UIBarButtonItem *infoButton = [[UIBarButtonItem alloc] initWithTitle:@"info" style:UIBarButtonItemStyleBordered target:self action:@selector(infoView)];
    
   // UIBarButtonItem *infoButton = [[UIBarButtonItem alloc] initWithCustomView:txtLabel];
    self.navigationItem.rightBarButtonItem =infoButton;
    
    NSString *linkerItem = selectedItem;
    //NSString *linkToParse = @"http://www.ua.rian.ru/export/rss2/index.xml";
    
    NSString *linkToParse = @"http://novosti.kr.ua/index.php/news?format=feed&type=rss";
    if ([linkerItem isEqual:@"Спорт"]) 
    {
        linkToParse = @"http://novosti.kr.ua/index.php/news/sports?format=feed&start=0&limit=5";
        self.title = @"Спорт";
    }
    else if ([linkerItem isEqual:@"Политика"])  
    {
        linkToParse = @"http://novosti.kr.ua/index.php/news/policy?format=feed&start=0&limit=5";
        self.title = @"Политика";
    }
    else if ([linkerItem isEqual:@"Экономика"])  
    {
        linkToParse = @"http://novosti.kr.ua/index.php/news/economics?format=feed&start=0&limit=5";
        self.title = @"Экономика";
    } 
    else if ([linkerItem isEqual:@"Культура"])  
    {
        linkToParse = @"http://novosti.kr.ua/index.php/news/culture?format=feed&start=0&limit=5";
        self.title = @"Культура";
    } 
    else if ([linkerItem isEqual:@"Официальная Хроника"])  
    {
        linkToParse = @"http://novosti.kr.ua/index.php/news/officialchronicles?format=feed&start=0&limit=5";
        self.title = @"Официальная Хроника";
    } 
    else if ([linkerItem isEqual:@"Последние события"])  
    {
        linkToParse = @"http://novosti.kr.ua/index.php/news/events?format=feed&start=0&limit=5";
        self.title = @"Последние события";
    } 
    
    
    
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
    NSURL *url = [NSURL URLWithString:linkToParse];
    NSURLRequest *theRequest=[NSURLRequest requestWithURL:url
                                              cachePolicy:NSURLRequestUseProtocolCachePolicy
                                          timeoutInterval:10.0];
    
    NSURLConnection *theConnection=[[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
    if (theConnection) {
        self.rssData = [NSMutableData data];
    } else {
        NSLog(@"Connection failed");
    }

}

- (void)infoView {
    
    InfoViewController *infoViewCon = [[InfoViewController alloc] 
                                       initWithNibName:@"InfoViewController" 
                                       bundle:nil];
    [self.navigationController pushViewController:infoViewCon animated:YES];
    
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    
    [rssData appendData:data];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
    //NSString *result = [[NSString alloc] initWithData:rssData encoding:NSUTF8StringEncoding];
    //NSLog(@"%@",result);
  
    
    self.news = [NSMutableArray array];
    NSXMLParser *rssParser = [[NSXMLParser alloc] initWithData:rssData];
    
    rssParser.delegate = self;
    [rssParser parse];
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict  {
    
    self.currentElement = elementName;
    if ([elementName isEqualToString:@"item"]) {
        self.currentTitle = [NSMutableString string];
        self.pubDate = [NSMutableString string];
        self.link = [NSMutableString string];
    }
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
    if ([currentElement isEqualToString:@"title"]) 
    {
		[currentTitle appendString:string];
	} 
    else if ([currentElement isEqualToString:@"pubDate"]) 
    {
		[pubDate appendString:string];
    }
    else if([currentElement isEqualToString:@"link"])
    {
        [link appendString:string];
    }
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
    if ([elementName isEqualToString:@"item"]) {
        NSDictionary *newsItem = [NSDictionary dictionaryWithObjectsAndKeys:currentTitle, @"title", pubDate, @"pubDate", link,@"link", nil];
        [news addObject:newsItem];
        self.currentTitle = nil;
        self.pubDate = nil;
        self.link = nil;
        self.currentElement = nil;
    }
}

- (void)parserDidEndDocument:(NSXMLParser *)parser {
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
    [viewtable reloadData];
}


- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
    NSLog(@"%@", error);
}



- (void)parser:(NSXMLParser *)parser parseErrorOccurred:(NSError *)parseError {
    NSLog(@"%@", parseError);
}

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [news count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
    }
    
    NSDictionary *newsItem = [news objectAtIndex:indexPath.row];
   
    
    
    cell.textLabel.text = [newsItem objectForKey:@"title"];
    cell.detailTextLabel.text = [newsItem objectForKey:@"pubDate"];
    
     [cell.textLabel setTextColor:[UIColor whiteColor]];
     [cell.detailTextLabel setTextColor:[UIColor whiteColor]];
    
    
    
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    WebViewController *webViewController = [[WebViewController alloc] initWithNibName:@"WebViewController" bundle:nil];
    
    NSDictionary *newsItem = [news objectAtIndex:indexPath.row];
    webViewController.linkPage = [newsItem objectForKey:@"link"];
    [self.navigationController pushViewController:webViewController animated:YES];
    
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
   
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end



























