//
//  VkViewController.m
//  TaskManadgerRss
//
//  Created by Pavel on 7/10/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "VkViewController.h"

@implementation VkViewController

@synthesize web;
@synthesize allPhoto;
@synthesize access_token;
@synthesize fullSerData;
@synthesize allmessages;
@synthesize allFriends;
@synthesize userImage;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];

}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    CAGradientLayer *bgLayer = [GradientBackground blackGradient];
    bgLayer.frame = self.view.bounds;
    [self.view.layer insertSublayer:bgLayer atIndex:0];
     UIBarButtonItem *logout = [[UIBarButtonItem alloc] initWithTitle:@"logout" style:UIBarButtonItemStyleBordered target:self action:@selector(logoutSel)];
    self.navigationItem.rightBarButtonItem = logout;
    
    offset = 0;
    self.access_token = [[NSUserDefaults standardUserDefaults] objectForKey:@"access_token"];
    if (access_token) {
        //[web removeFromSuperview];
        //self.web = nil;
        web.hidden = YES;
        // URL setting for VKAPI
        self.allPhoto = [NSMutableArray array];
        NSString *photoRequest = [NSString stringWithFormat:photoLink, access_token, offset];
        [APIDownload downloadWithURL:photoRequest delegate:self sel:@selector(didLoadPhotoList:)];
        
        self.allmessages = [NSMutableArray array];
        NSString *messageRequest = [NSString stringWithFormat:messageLink, access_token, offset];
        [APIDownload downloadWithURL:messageRequest delegate:self sel:@selector(didLoadMessage:)];
        
        self.allFriends = [NSMutableArray array];
        NSString *friendsRequest = [NSString stringWithFormat:friendLink, access_token, offset];
        [APIDownload downloadWithURL:friendsRequest delegate:self sel:@selector(didLoadFriendsList:)];
        
        
    } else {
        NSString *authLink = [NSString stringWithFormat:@"http://api.vk.com/oauth/authorize?client_id=%@&scope=wall,photos,messages,friends&redirect_uri=http://api.vk.com/blank.html&display=touch&response_type=token", APIid];
        NSURL *url = [NSURL URLWithString:authLink];

        web.hidden = NO;
        [web loadRequest:[NSURLRequest requestWithURL:url]];  
    }   
}

- (void) logoutSel {
   
    
    NSString *logout = @"http://api.vk.com/oauth/logout";
    
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:logout] cachePolicy:NSURLRequestReloadIgnoringLocalCacheData timeoutInterval:60.0]; 
    NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];
    if(responseData){
        isAuth = NO;
        [[NSUserDefaults standardUserDefaults] removeObjectForKey:@"VKAccessUserId"];
        [[NSUserDefaults standardUserDefaults] removeObjectForKey:@"access_token"];
        [[NSUserDefaults standardUserDefaults] removeObjectForKey:@"VKAccessTokenDate"];
        [[NSUserDefaults standardUserDefaults] synchronize];
        
        web.hidden = NO;
        [self sendSuccessWithMessage:@"Выход произведен успешно!"];
        
        NSString *authLink = [NSString stringWithFormat:@"http://api.vk.com/oauth/authorize?client_id=%@&scope=wall,photos,messages&redirect_uri=http://api.vk.com/blank.html&display=touch&response_type=token", APIid];
        NSURL *url = [NSURL URLWithString:authLink];
        
        web.hidden = NO;
        [web loadRequest:[NSURLRequest requestWithURL:url]]; 
        
        
    }
}

- (void)viewDidUnload
{
    [super viewDidUnload];
   
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (NSString*)stringBetweenString:(NSString*)start 
                       andString:(NSString*)end 
                     innerString:(NSString*)str {
    NSScanner* scanner = [NSScanner scannerWithString:str];
    [scanner setCharactersToBeSkipped:nil];
    [scanner scanUpToString:start intoString:NULL];
    if ([scanner scanString:start intoString:NULL]) {
        NSString* result = nil;
        if ([scanner scanUpToString:end intoString:&result]) {
            return result;
        }
    }
    return nil;
}

- (IBAction)sendTextAPIVK:(id)sender {
    
    NSString *user_id = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessUserId"];
    NSString *accessToken = [[NSUserDefaults standardUserDefaults] objectForKey:@"access_token"];
    NSString *text = @"Hello World !";
    NSString *sendTextMessage = [NSString stringWithFormat:@"https://api.vk.com/method/wall.post?owner_id=%@&access_token=%@&message=%@", user_id, accessToken, [self URLEncodedString:text]];
    NSDictionary *result = [self sendRequest:sendTextMessage withCaptcha:YES];
    NSString *errorMsg = [[result objectForKey:@"error"] objectForKey:@"error_msg"];
    if(errorMsg) {
        [self sendFailedWithError:errorMsg];
    } else {
        [self sendSuccessWithMessage:@"Текст размещен на стене!"];
    }
}

- (IBAction)sendImageAPIVK:(id)sender {
}

- (IBAction)getPhotoList:(id)sender {
    
    VKViewPhotoListController *photoListViewController = [[VKViewPhotoListController alloc]  initWithNibName:@"VKViewPhotoListController" bundle:nil];
    photoListViewController.allPhoto = allPhoto;
    [self.navigationController pushViewController:photoListViewController animated:YES];
}

- (IBAction)getMessages:(id)sender {
    
    VkViewMessagesListController *messList = [[VkViewMessagesListController alloc] initWithNibName:@"VkViewMessagesListController" bundle:nil];
    messList.allMess = allmessages;
    [self.navigationController pushViewController:messList animated:YES];
}

- (IBAction)getFriendsList:(id)sender {
    
    VkViewFriendListController *friendList = [[VkViewFriendListController alloc] initWithNibName:@"VkViewFriendListController" bundle:nil];
    friendList.friends = self.allFriends;
    //friendList.friendsIco = [self didLoadFriendImage:allFriends];
    [self.navigationController pushViewController:friendList animated:YES];
}

- (IBAction)addNewPlaces:(id)sender {
}

- (IBAction)sendMessage:(id)sender {
    
    VkCreateMessageViewController *message = [[VkCreateMessageViewController alloc] initWithNibName:@"VkCreateMessageViewController" bundle:nil];
    message.isWall = YES;
    [self.navigationController pushViewController:message animated:YES];

}





- (void) sendFailedWithError:(NSString *)error {
    if(isCaptcha) return;
    UIAlertView *myAlertView = [[UIAlertView alloc] initWithTitle:@"Ошибка!" message:error delegate:self cancelButtonTitle:@"OK" otherButtonTitles: nil];
    [myAlertView show];

}

- (void) sendSuccessWithMessage:(NSString *)message {
    UIAlertView *myAlertView = [[UIAlertView alloc] initWithTitle:@"Успешно!" message:message delegate:self cancelButtonTitle:@"OK" otherButtonTitles: nil];
    [myAlertView show];

}

- (NSString *)URLEncodedString:(NSString *)str
{
    NSString *result = (__bridge_transfer NSString *)CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault, (__bridge_retained CFStringRef)str, NULL, CFSTR("!*'();:@&=+$,/?%#[]"), kCFStringEncodingUTF8);
	return result;
}

- (NSDictionary *) sendRequest:(NSString *)reqURl withCaptcha:(BOOL)captcha {
    // Если это запрос после ввода капчи, то добавляем в запрос параметры captcha_sid и captcha_key
    if(captcha == YES){
        NSString *captcha_sid = [[NSUserDefaults standardUserDefaults] objectForKey:@"captcha_sid"];
        NSString *captcha_user = [[NSUserDefaults standardUserDefaults] objectForKey:@"captcha_user"];
        // Добавляем к запросу данные для капчи. Не забываем что введенный пользователем текст нужно обработать.
        reqURl = [reqURl stringByAppendingFormat:@"&captcha_sid=%@&captcha_key=%@", captcha_sid, [self URLEncodedString: captcha_user]];
    }
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:reqURl] cachePolicy:NSURLRequestReloadIgnoringLocalCacheData timeoutInterval:60.0]; 
    
    // Для простоты используется обычный запрос NSURLConnection, ответ сервера сохраняем в NSData
    NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];
    
    // Если ответ получен успешно, можем его посмотреть и заодно с помощью JSONKit получить NSDictionary
    
    if(responseData){
        
        CJSONDeserializer *deserializer = [CJSONDeserializer new];
        NSDictionary *dict = [deserializer deserializeAsDictionary:responseData error:nil];
        //NSDictionary *dict = [[JSONDecoder decoder] parseJSONData:responseData]; //for JSONKit
        
        
        // Если есть описание ошибки в ответе
        NSString *errorMsg = [[dict objectForKey:@"error"] objectForKey:@"error_msg"];
        
        // Если требуется ввод капчи
        if([errorMsg isEqualToString:@"Captcha needed"]){
            isCaptcha = YES;
            // Сохраняем параметры для капчи
            NSString *captcha_sid = [[dict objectForKey:@"error"] objectForKey:@"captcha_sid"];
            NSString *captcha_img = [[dict objectForKey:@"error"] objectForKey:@"captcha_img"];
            [[NSUserDefaults standardUserDefaults] setObject:captcha_img forKey:@"captcha_img"];
            [[NSUserDefaults standardUserDefaults] setObject:captcha_sid forKey:@"captcha_sid"];
            // Сохраняем url запроса чтобы сделать его повторно после ввода капчи
            [[NSUserDefaults standardUserDefaults] setObject:reqURl forKey:@"request"];
            [[NSUserDefaults standardUserDefaults] synchronize];
            
            [self getCaptcha];
        }
        
        return dict;
    }
    return nil;
}

- (void) getCaptcha {
    NSString *captcha_img = [[NSUserDefaults standardUserDefaults] objectForKey:@"captcha_img"];
    UIAlertView *myAlertView = [[UIAlertView alloc] initWithTitle:@"Введите код:\n\n\n\n\n"
                                                          message:@"\n" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
    
    UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake(12.0, 45.0, 130.0, 50.0)];
    imageView.image = [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:captcha_img]]];
    [myAlertView addSubview:imageView];
    
    UITextField *myTextField = [[UITextField alloc] initWithFrame:CGRectMake(12.0, 110.0, 260.0, 25.0)];
    [myTextField setBackgroundColor:[UIColor whiteColor]];
    
    // Отключаем автокорректировку
    myTextField.autocorrectionType = UITextAutocorrectionTypeNo;
    // Отключаем автокапитализацию
    myTextField.autocapitalizationType = UITextAutocapitalizationTypeNone;
    myTextField.tag = 33;
    
    [myAlertView addSubview:myTextField];
    [myAlertView show];

}

-(void)webViewDidFinishLoad:(UIWebView *)webView {
    self.access_token = [self stringBetweenString:@"access_token=" 
                                        andString:@"&" 
                                      innerString:[[[webView request] URL] absoluteString]];
    
    NSArray *userAr = [[[[webView request] URL] absoluteString] componentsSeparatedByString:@"&user_id="];
    NSString *user_id = [userAr lastObject];
    if(user_id){
        [[NSUserDefaults standardUserDefaults] setObject:user_id forKey:@"VKAccessUserId"];
    }
    
    if (access_token) {
        [[NSUserDefaults standardUserDefaults] setObject:access_token forKey:@"access_token"];
        [[NSUserDefaults standardUserDefaults] setObject:[NSDate date] forKey:@"VKAccessTokenDate"];
        [[NSUserDefaults standardUserDefaults] synchronize];
        self.allPhoto = [NSMutableArray array];
        NSString *photoRequest = [NSString stringWithFormat:photoLink, access_token, offset];
        [APIDownload downloadWithURL:photoRequest delegate:self sel:@selector(didLoadPhotoList:)];
        
        self.allmessages = [NSMutableArray array];
        NSString *messageRequest = [NSString stringWithFormat:messageLink, access_token, offset];
        [APIDownload downloadWithURL:messageRequest delegate:self sel:@selector(didLoadMessage:)];
        
        self.allFriends = [NSMutableArray array];
        NSString *friendsRequest = [NSString stringWithFormat:friendLink, access_token, offset];
        [APIDownload downloadWithURL:friendsRequest delegate:self sel:@selector(didLoadFriendsList:)];
        
       
        web.hidden = YES;
    }
}


- (void)didLoadFriendsList:(APIDownload*)request {
    CJSONDeserializer *deserializer = [CJSONDeserializer new];
    NSDictionary *dict = [deserializer deserializeAsDictionary:request.downloadData error:nil];
    self.allFriends =  [dict objectForKey:@"response"];
}


- (void)didLoadMessage:(APIDownload*)request {
    CJSONDeserializer *deserializer = [CJSONDeserializer new];
    NSDictionary *dict = [deserializer deserializeAsDictionary:request.downloadData error:nil];
   
   // NSLog(@"%@", dict);
    
    NSArray *response = [dict objectForKey:@"response"];
    NSArray *photos = [response subarrayWithRange:NSMakeRange(1, response.count-1)];
    
    for (int i=0; i<photos.count; i++) {
        NSDictionary *messages = [photos objectAtIndex:i];
        NSString *message = [messages objectForKey:@"body"];
      
        NSMutableDictionary *item = [NSMutableDictionary dictionaryWithObjectsAndKeys:message, @"message", nil];
        [allmessages addObject:item];
    }
    
    NSInteger maxCount = [[response objectAtIndex:0] intValue];
    if ([allmessages count] != maxCount) {
        offset +=100;
        NSString *photoRequest = [NSString stringWithFormat:messageLink, access_token, offset];
        [APIDownload downloadWithURL:photoRequest delegate:self sel:@selector(didLoadMessage:)];
    }    
}


- (void)didLoadPhotoList:(APIDownload*)request {
    CJSONDeserializer *deserializer = [CJSONDeserializer new];
    NSDictionary *dict = [deserializer deserializeAsDictionary:request.downloadData error:nil];
    fullSerData = dict;
    
    //NSLog(@"%@", dict);
    
    NSArray *response = [dict objectForKey:@"response"];
    NSArray *photos = [response subarrayWithRange:NSMakeRange(1, response.count-1)];
    
    for (int i=0; i<photos.count; i++) {
        NSDictionary *photo = [photos objectAtIndex:i];
        NSString *smallImageURL = [photo objectForKey:@"src_small"];
        NSString *bigImageUrl = [photo objectForKey:@"src_big"];
        NSMutableDictionary *item = [NSMutableDictionary dictionaryWithObjectsAndKeys:smallImageURL, @"small_url", bigImageUrl, @"big_url", nil];
        [allPhoto addObject:item];
        
        APIDownload *photoResponse = [APIDownload downloadWithURL:smallImageURL delegate:self];
        photoResponse.tag = [allPhoto indexOfObject:item];
    }
    
    NSInteger maxCount = [[response objectAtIndex:0] intValue];
    if ([allPhoto count] != maxCount) {
        offset +=100;
        NSString *photoRequest = [NSString stringWithFormat:photoLink, access_token, offset];
        [APIDownload downloadWithURL:photoRequest delegate:self sel:@selector(didLoadPhotoList:)];
    }    
    
  //  [photoList reloadData];
}



- (void)APIDownload:(APIDownload*)request {
    UIImage *photo = [UIImage imageWithData:request.downloadData];
    NSMutableDictionary *item = [allPhoto objectAtIndex:request.tag];
    [item setObject:photo forKey:@"photo"];
   // [photoList reloadData];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
   

}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return allPhoto.count;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 72.0f;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault 
                                       reuseIdentifier:CellIdentifier];
    }
    
    NSDictionary *item = [allPhoto objectAtIndex:indexPath.row];
    cell.imageView.image = [item objectForKey:@"photo"];
    
    return cell;
}

@end
