//
//  VkViewFriendListController.m
//  TaskManadgerRss
//
//  Created by Pavel on 7/12/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "VkViewFriendListController.h"


@implementation VkViewFriendListController

@synthesize tableView;
@synthesize friends;
@synthesize friendsIco;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    CAGradientLayer *bgLayer = [GradientBackground blackGradient];
    bgLayer.frame = self.view.bounds;
    [self.view.layer insertSublayer:bgLayer atIndex:0];
    [self didLoadFriendImageToList:friends];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
   
    NSDictionary *item = [friends objectAtIndex:indexPath.row];
 
    VkFriendProfileController *friendProfile = [[VkFriendProfileController alloc] initWithNibName:@"VkFriendProfileController" bundle:nil];
    
    friendProfile.friendOne = item;
    
    
    
    [self.navigationController pushViewController:friendProfile animated:YES];
    
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return friends.count;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 72.0f;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle 
                                      reuseIdentifier:CellIdentifier];
    }
    
    NSDictionary *item = [friendsIco objectAtIndex:indexPath.row];
    cell.imageView.image = [item objectForKey:@"photo"];
    
    
    NSDictionary *itemName = [friends objectAtIndex:indexPath.row];
    cell.textLabel.text = [[[itemName objectForKey:@"first_name"] stringByAppendingString:@" "] stringByAppendingString:[itemName objectForKey:@"last_name"]];
    NSString *online=[NSString stringWithFormat:@"%@", [itemName objectForKey:@"online"]];
    if([online isEqualToString:@"1"]){
        cell.detailTextLabel.text = @"online";
    }
        
    [cell setBackgroundColor:[UIColor whiteColor]];
    cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;

    return cell;
}

- (void)didLoadFriendImageToList:(NSMutableArray *)friendsList {
    
    friendsIco = [[NSMutableArray alloc] init];
    for (int i = 0; i < friendsList.count; i++) {
        
        NSDictionary *itemArr = [friendsList objectAtIndex:i];
        NSString *path = [itemArr objectForKey:@"photo"];
        NSMutableDictionary *item = [NSMutableDictionary dictionaryWithObjectsAndKeys:path, @"url", nil];      
        [friendsIco addObject:item];
        APIDownload *photoResponse = [APIDownload downloadWithURL:path delegate:self];
        photoResponse.tag = [friendsIco indexOfObject:item];
    }
}

- (void)APIDownload:(APIDownload*)request {
    UIImage *photo = [UIImage imageWithData:request.downloadData];
    NSMutableDictionary *item = [friendsIco objectAtIndex:request.tag];
    [item setObject:photo forKey:@"photo"];
    [tableView reloadData];
}




@end
